<?php 
#######################################################################################
#
#  STORM PREDICTION CENTER REPORTS
#  version 1.09
#
#  This program is free and no license is required.
#  Email me for any questions regarding this program.
#
#  curly{at}ricksturf.com
#
#######################################################################################

////  SETTINGS  ////

$upTime        = 600;                     // time in seconds to retain cache file before updating  600=10 minutes  3600=60 minutes
$cacheFileDir  = './cache/';              // default cache file directory
$ourTZ         = 'America/New_York';      // Time Zone     http://www.php.net/manual/en/timezones.america.php
$sortEvent     = 'latest';                // default sort events by  'severity'   'latest'   'first'  'state'
$divWidth      = '620px';                 // total width - minimum: 580px  -  Examples:  640px    90%
$showWFO       = true ;                   // true= show weather forecast office    false=don't show weather forecast office
$longWFO       = true;                    // true=show (City, State) for WFO   false=show WFO code (IWX)    used only is above is true
$imagesDir     = './ajax-images/';        // path to image folder
$enhanceMap    = true;                    // true=enhance map colors   false=use original map

// Change colors
$bkgColor  = '#DDD';     // Background color   Examples:  "gray"  "#CCC"   "#CCCCCC"
$tBkg      = '#FAEBEB';  // Tornado report background color  RED
$tFont     = '#500';     // Tornado report font color   red tint
$wBkg      = '#EBEBFA';  // Wind report background color  BLUE
$wFont     = '#005';     // Wind report font color   blue tint
$hBkg      = '#EBFAEB';  // Hail report background color  GREEN
$hFont     = '#050';     // Hail report font color   green tint
$dtColor   = '#FC0';     // Date & time color  Examples:   "#FC0"   "#FFCC00"   "white"

////  END OF SETTINGS  ////

#######################################################################################
#
#  KNOWN ISSUES
#    
#    Reports are not cleared at the time specified by the SPC
#    Additional commas are placed in the comma delimited file from the SPC
#    States or locations may contain unrelated data from the SPC
#    Maps and data are not always updated, or cleared, at the same time by the SPC
#
#  Issues that can be controlled have been addressed in this script to reduce errors.
#  However, data output by the SPC sometimes varies and may cause undesired results.
#
#######################################################################################

// self downloader code
if (isset($_REQUEST['sce']) && ( strtolower($_REQUEST['sce']) == 'view' or
    strtolower($_REQUEST['sce']) == 'show') ) {
   //--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');

   readfile($filenameReal);
   exit;
} 

//ini_set('display_errors', 1);
//error_reporting(E_ALL);

echo "<!-- inc-SPCreports.php V1.09 - 22-June-2018 -->\n";   // display version
$start_timer = script_time();

// overrides from the Carter Lake Settings.php file (if applicable)
global $SITE;
if(isset($SITE['cacheFileDir'])) {$cacheFileDir = $SITE['cacheFileDir']; }
if (isset($SITE['imagesDir']))   {$imagesDir = $SITE['imagesDir'];} 
if(isset ($SITE['tz']))          {$ourTZ = $SITE['tz'];}
if(!function_exists('date_default_timezone_set')) {
  putenv("TZ=" . $ourTZ);
} else {
  date_default_timezone_set("$ourTZ");
}

$uts = date("U");       // current unix time stamp
$mb      = '';          // set variable
$noted   = '';          // set variable
$sData   = '';          // set variable
$tData   = '';          // set variable
$badDate = '';          // set variable
$repSort = '';          // set variable
$chckdA = '';           // set variable
$chckdB = '';           // set variable
$chckdC = '';           // set variable
$chckdD = '';           // set variable
$adjMap = '';           // set variable
$sortButtons = '';      // set variable
$formatData = array();  // set variable
$hMap = true;           // set variable
$searched = 'today';    // set variable
$nwswfo[0] = '';        // set variable
$month = date("n");     // set current month
$day = date("j");       // set current day
$yesterDay = date("j",strtotime("-1 days"));
$yMonth = date("n",strtotime("-1 days"));
$yYear = date("Y",strtotime("-1 days"));
$year = date("Y");      // set current year
$cutoff_time = (date("O")+"1200")/100;                               // set report span time according to time zone
$urlSPC = 'https://www.spc.noaa.gov/climo/reports/today.csv';         // data URL
$urlMAP = 'https://www.spc.noaa.gov/climo/reports/today.gif';         // map URL
$locTZ = '<span style="font-size:90%"> &nbsp;'.date("T").'</span>';  // local time zone

// get path info & protect for cross-site scripting vulnerability
($_SERVER['REQUEST_URI']) ? $sri = htmlspecialchars(strip_tags($_SERVER['REQUEST_URI'])) : $sri = '';
$sri2 = str_replace('#SA', '', $sri);  // clean up for drop down menu

// set borders
$bbrdr = 'border-bottom:thin solid black';       // bottom
$lbrdr = 'border-left:thin solid black';         // left
$rbrdr = 'border-right:thin solid black';        // right
$tbrdr = 'border-top:thin solid black';          // top
$sbrdr = 'border-right:thin solid black; '.
         'border-left:thin solid black';         // side
				 
// month array for drop down menu
$mNames = array('January','February','March','April',
                'May','June','July','August','September',
                'October','November','December');

$showDate = $mNames[$month-1].' '.$day.', '.$year;     // display date format

// construct the date drop down menu
$nMonth = $month;
$chartDay = $day;
if(date("G") < $cutoff_time) {                      // IF viewing reports for 'today' and the hour is less than cut-off time
	$chartDay = $yesterDay;                           //   modify the day to back up 1 day
	$month = $yMonth;
	$year = $yYear;
	$chartDay = date("j", mktime(date("G"), date("i"), 0, $month, $chartDay, $year));   //   modify day to yesterday
	$nMonth = date("n", mktime(date("G"), date("i"), 0, $month, $chartDay, $year)); //   modify month
}
/*############### Debug Code Start ###############
	$chartDay = $yesterDay;                                                          //   modify the day to back up 1 day
	$chartDay = date("j", mktime(date("G"), date("i"), 0, $month, $chartDay, $year));   //   modify day to yesterday
	$nMonth = date("n", mktime(date("G"), date("i"), 0, $month, $chartDay, $year)); //   modify month
############### Debug Code End #################*/
$nNMonth = $mNames[$nMonth-1];
# echo '$nNMonth: '.$nNMonth.', $chartDay: '.$chartDay.', $cutoff_time: '.$cutoff_time.'<br/>'; // Debug Code
function show_months() {
	global $mNames,$nNMonth;
	$moStr = '';
	for ($i=1; $i<13; $i++) {
		$moStr .= '<option '.($mNames[$i-1]==$nNMonth?'selected="selected " ':'').'value="'.($i<10?'0'.$i:$i).'">'.$mNames[$i-1].'</option>';
	}
	return ($moStr);
}
function show_days() {
	global $chartDay;
	$dayStr = '';
	for ($i=1; $i<=31; $i++) {
		$dayStr .= '<option '.($chartDay==$i?'selected="selected" ':'').'value="'.($i<10?'0'.$i:$i).'">'.$i.'</option>';
	}
	return ($dayStr);
}
function show_years() {
	$yearStr = '';
	for ($i=5;$i<date("y");$i++) {  
		$yearStr .= '<option value="'.($i<10?'0'.$i:$i).'">20'.($i<10?'0'.$i:$i).'</option>';
	}
	$yearStr .= '<option selected="selected" value="'.date("y").'">20'.date("y").'</option>';
	return ($yearStr);
}
$ddm = ' <tr>
  <td align="center" style="font-size: 12px; text-align:center; padding:0px 0px 10px; color:black">
   <form action="'.$sri2.'#TA" method=\'get\' accept-charset=\'utf-8\'>
    <div>
     <select name=\'mo\'>';
$ddm .= show_months();
$ddm .= '     </select>
     <select name=\'dt\'>';
	$ddm .= show_days();
$ddm .= '     </select>
     <select name=\'yr\'>';
$ddm .= show_years();
$ddm .= '     </select>
     <input name=\'submit\' type=\'submit\' value=\'Submit\' />
    </div>
   </form>
  </td>
 </tr>
';

// get the user input date
if(!empty($_GET['mo']) && !empty($_GET['dt']) && !empty($_GET['yr'])) {                                // IF all dates are entered
    $month = htmlspecialchars(strip_tags($_GET['mo']));                                                //     get month entered
    $day = htmlspecialchars(strip_tags($_GET['dt']));                                                  //     get day entered
    $year = htmlspecialchars(strip_tags($_GET['yr']));                                                 //     get year entered
    $yer = '20'.$year;                                                                                 //     copy year entered & add 20 prefix

  if(checkdate($month,$day,$yer) == false){                                                            //   IF not a valid date
    $badDate = $mNames[$month-1].' '.$day.', '.$yer." does not exist <br />\n";                        //     display bad date
    $searched = 'today';                                                                               //     change reports to today
  }
  else {                                                                                               //   OR ELSE
    $showDate = $mNames[$month-1].' '.$day.', '.$yer;                                                  //     display date entered
    if(mktime(date("G"), date("i"), date("s"), $month, $day, $year) >= $uts) {                         //     IF date entered is greater than or equal to today
      if(mktime(date("G"), date("i"), date("s"), $month, $day, $year) > $uts) {                        //       IF date entered is greater than today
        $badDate = date("M d Y",mktime(date("G"), date("i"), date("s"), $month, $day, $year))." is in the future <br />\n"; // display date & notice
      }
      if(mktime(date("G"), date("i"), date("s"), $month, $day, $year) == $uts) {                       //       IF date entered is today
        $badDate = '';                                                                                 //          don't display bad date
      }
      $searched = 'today';                                                                             //       searched day is set to today
      $showDate = date("F d\, Y",filemtime($cacheFileDir.'nwsCSV'.$searched.'.txt'));                  //       change date to today
      $dataCache = $cacheFileDir.'nwsCSV'.$searched.'.txt';                                            //       use today for a cache file
			if (date("G") < $cutoff_time) {																																	 //				display yesterday's date
				$mDay = $yesterDay;                                                          										 //   modify the day to back up 1 day
				$month = $yMonth;
				$year = $yYear;
				$day = date("d", mktime(date("G"), date("i"), 0, $month, $mDay, $year));   										 //   modify day to yesterday
				$month = date("n", mktime(date("G"), date("i"), 0, $month, $mDay, $year)); 										 //   modify month
				$showDate = date("F d\, Y", mktime(date("G"), date("i"), 0, $month, $mDay, $year));						 //		display yesterday "month day, year"
			}
    }
    else {                                                                                             //     OR ELSE
      $searched = $year.$month.$day;                                                                   //       use the date entered for data & map
      $urlSPC = 'https://www.spc.noaa.gov/climo/reports/'.$year.$month.$day.'_rpts.csv';                //       data URL for user input
      $urlMAP = 'https://www.spc.noaa.gov/climo/reports/'.$year.$month.$day.'_rpts.gif';                //       map URL for user input
    }
  }
}

// IF a date is missing, display notice
if(isset($_GET['mo']) && empty($_GET['mo']) || isset($_GET['dt']) && empty($_GET['dt']) || isset($_GET['yr']) && empty($_GET['yr'])) {
  $badDate = "All dates need to be selected<br />\n";
}

// set variable for url linking
($searched == 'today') ? $viewURL = 'today' : $viewURL = $searched.'_rpts';

// fix date/day if todays reports are viewed the next day before the next SPC day begins (or cut-off time)
if($searched == 'today' and date("G") < $cutoff_time) {                      // IF viewing reports for 'today' and the hour is less than cut-off time
  $mDay = $yesterDay;                                                          //   modify the day to back up 1 day
	$month = $yMonth;
	$year = $yYear;
  $day = date("d", mktime(date("G"), date("i"), 0, $month, $mDay, $year));   //   modify day to yesterday
  $month = date("n", mktime(date("G"), date("i"), 0, $month, $mDay, $year)); //   modify month
	$showDate = $mNames[$month-1].' '.$day.', '.$year;     										 // 	display yesterday
}
	
// check if map filetime from yesterday hasn't updated 15 minutes after the SPC reset time
if($searched == 'today' and date("G") == $cutoff_time and date("i") <= 15) {   // IF the hour (24-hour format) is equal to cut-off time and less than 15 minutes after the hour
  $check_day = map_data($urlMAP);                                              //   cull map information
  $sd = explode('|', $check_day);                                              //   split the data   size=$sd[0]   date=$sd[1]
  if($sd[0] == 0) {                                                            //   IF the map information is not available
    $sd = '';                                                                  //     clear the variable                     
    sleep(1);                                                                  //     wait for a second
    $check_day = map_data($urlMAP);                                            //     cull information again
    $sd = explode('|', $check_day);                                            //     split the data   size=$sd[0]   date=$sd[1]
  }
  if($sd[0] !== 0 and $sd[1] < $cutoff_time) {                                 // IF map information is available & update hour is less than cut-off time
    $mDay = $yesterDay;                                                          //   back up 1 day
		$month = $yMonth;
		$year = $yYear;
    $day = date("d", mktime(date("G"), date("i"), 0, $month, $mDay, $year));   //   modify day to yesterday
    $month = date("n", mktime(date("G"), date("i"), 0, $month, $mDay, $year)); //   modify month
  }
}

$dataCache = $cacheFileDir.'nwsCSV'.$searched.'.txt';       // file name for the cache file

if(!$enhanceMap) {                                   // IF NOT enhance map
  $mw = '582';                                       //   set map width
  $mh = '408';                                       //   set map height
  $mt = 'gif';                                       //   set map extension
  $mb = 'style="border-top: thin solid black; border-right: thin solid black; border-bottom: thin solid black"';
}
else {
  $mw = '578';                                       //   set map width
  $mh = '410';                                       //   set map height
  $mt = 'png';                                       //   set map extension
}

if (!empty($_GET['ur'])) {                                  // IF you want to manually update the report   ?ur=1
  $datacacheTime = 0;                                       //   set cache file time to 0 (expired)
  $noted .= "<!-- Report maunually updated -->\n";          //   display notice
}

// IF the cache file exists, get the file modified time OR ELSE set a cache time to zero to invoke a file fetch
(file_exists($dataCache)) ? $datacacheTime = date("U",filemtime($dataCache)) : $datacacheTime = 0;
 
// delete old cache files
foreach (glob($cacheFileDir.'nwsCSV*') as $nwsCache) {      // for each cache file
  $cachedNWSdata = date("U",filemtime($nwsCache));          //  get the last modified time of the cache file
  if($uts - $cachedNWSdata > $upTime) {                     //   IF the cache file has expired
    $noted .= "<!-- $nwsCache expired and deleted -->\n";   //     display remark
    unlink($nwsCache);                                      //     delete expired cache files
  }
}

// IF the map file is missing, set cache file time at zero to update the cache files
(!file_exists( $cacheFileDir.'nwsCSV'.$searched.'.'.$mt)) ? $datacacheTime = 0 : $datacacheTime = $datacacheTime;

// use cache data if it has not expired or fetch fresh data
if(file_exists($dataCache) and $uts - $datacacheTime < $upTime) {     // IF cache file exists and cache file has not expired
  $priData = implode('', file($dataCache));                           //   get data from the cache file
  $noted .= "<!-- Map & data loaded from cache file -->\n";           //   display remark
  $lcfu = date("g:i a",filemtime($dataCache));                        //   configure cache file time
  $noted .= "<!-- Map & data cache file last updated at $lcfu -->\n"; //   display remark for using cache file
  $mapfile = $cacheFileDir.'nwsCSV'.$searched.'.'.$mt;                //   set map file variable
  $adjMap = false;                                                    //   set map adjustment
} 
else {                                                                // OR ELSE
  $mapData = map_data($urlMAP);                                       //   check for valid map file
  $sd = explode('|', $mapData);                                       //   split the data   size=$sd[0]   date=$sd[1]
  if($sd[0] == '0') {                                                 //   IF the map information is not available
    $sd = '';                                                         //     clear the variable                     
    sleep(1);                                                         //     wait for a second
    $mapData = map_data($urlMAP);                                     //     cull information again
    $sd = explode('|', $mapData);                                     //     split the data   size=$sd[0]   date=$sd[1]
    $noted .= "<!-- 2nd chance to get map -->\n";                     //     display remark
  }
  if($sd[0] !== '0') {                                                //   IF map information is available
    $adjMap = true;                                                   //     set map as valid
  }
  $priData = curl_get_data($urlSPC);                                  //   get data from SPC
  if($haveData <> '' and $adjMap) {                                   //   IF cull data is valid & map is valid
    $mapfile = $urlMAP;                                               //     set map URL location
    $adjMap = true;                                                   //     set map adjustment
    $cfo = fopen($dataCache , 'w');                                   //     open the cache file
    if(!$cfo) {                                                       //     IF unable to open cache file for writing
      $noted .= "<!-- unable to open cache file -->\n";               //       display remark
    } 
    else {                                                            //   OR ELSE
      $write = fputs($cfo, $priData);                                 //     write the forecast data
      fclose($cfo);                                                   //     close the cache file
      $nowTime = date("g:i a");                                       //     get the time at writing cache file
      $noted .= "<!-- Map & data file updated at $nowTime -->\n";     //     display remark
    } 
  }
}

####################     MAP    #######################
// change map colors
if($adjMap and $enhanceMap and $hMap) {                     // IF update cache file and have obtained map
  $mapimage = imagecreatefrompng($mapfile);                 //   get the file
  if($mapimage) { 
    $mapimageA = imagecreatefrompng($urlMAP);
    $silver = imagecolorat($mapimageA,180,1);
    $dgrey = imagecolorat($mapimageA,71,31);
    imagecolorset($mapimage, $silver, 200, 185, 153);       //   change gray land area color in map to another color
    imagecolorset($mapimage, $dgrey, 110, 110, 110);        //   change border color in map to another color
    imagecopy($mapimage, $mapimageA, 6, 358, 6, 350, 3, 3);
    imagecopy($mapimage, $mapimageA, 6, 400, 6, 350, 3, 3);
    $lblue = imagecolorat($mapimage,4,4);
    imagecolortransparent($mapimage, $lblue);
    $im = imagecreatetruecolor(578, 410);
    $dblue = imagecolorallocate($im, 74, 160, 215);         //  these values change the color of the water
    imagefilledrectangle($im, 1, 1, 576, 408, $dblue);
    imagecopy($im, $mapimage, 1, 1, 4, 0, 576, 410);
    imagepng($im, $cacheFileDir.'nwsCSV'.$searched.'.png');
    imagedestroy($im);
    imagedestroy($mapimage);
    imagedestroy($mapimageA);
  }
  // If there is a problem getting the image, display error
  else {
    $imA  = imagecreatetruecolor(578, 410);
    $bgc = imagecolorallocate($imA, 102, 168, 220);
    $tc  = imagecolorallocate($imA, 0, 0, 0);
    imagefilledrectangle($imA, 1, 1, 576, 408, $bgc);
    imagestring($imA, 2, 170, 200, 'Error loading the image.', $tc);
    imagepng($imA, $cacheFileDir.'nwsCSV'.$searched.'.png');
    imagedestroy($imA);
    imagedestroy($mapimage);
  }
}
// standard map copying policy
if($adjMap and !$enhanceMap and $hMap) {                           // IF time to update map but NOT enhanced map
  if (!copy($mapfile, $cacheFileDir.'nwsCSV'.$searched.'.gif')) {  //   IF can't copy original amp
    $noted .= "<!-- failed to copy original map file -->\n";       //     display remark
  }
  $noted .= "<!-- Original map used -->\n";                        //   display remark
}
// map image location & display
$spc_map = '<img src="'.$cacheFileDir.'nwsCSV'.$searched.'.'.$mt.'" width="'.$mw.'" height="'.$mh.'" alt="Map not available" '.$mb.'/>';

// If the map is not available, display notice
(!$hMap) ? $spc_map = 'Map is not available at this time' : $spc_map = $spc_map;
###################   END OF MAP   ##################################

$priData = preg_replace("/(\d{4})\,/", '"${1}",', $priData);                      // add double quotes to time

// split up the data from a csv format into tornado, wind, hail
$sData = preg_split("/^Time,[.*\n]|(.*Time,)/", $priData, -1, PREG_SPLIT_NO_EMPTY); 

// arrange the data to a usable format
foreach($sData as $sdk  => $sdv) {                                                 // FOR EACH event
  $sdv = explode("\n", trim($sdv));                                                //   split up data by line
  (preg_match("/F[_|-]Scale/Ui",$sdv[0])) ? $sdv[0] = 'TORNADO' : $sdv[0] = $sdv[0];   //   replace F-Scale with TORNADO
  (preg_match("/Speed/Ui",$sdv[0]))   ? $sdv[0] = 'WIND' : $sdv[0] = $sdv[0];      //   replace Speed with WIND
  (preg_match("/Size/Ui",$sdv[0]))    ? $sdv[0] = 'HAIL' : $sdv[0] = $sdv[0];      //   replace Size with HAIL
  if(isset($sdv[1])) {                                                             //   IF event has data
    $cSDV = count($sdv);                                                           //     count the data
    for ($i=1;$i<$cSDV;$i++) {                                                     //     for each piece of dat
      $fData = preg_split('/,/', $sdv[$i], 8);                                     //       split the data by comma into 8 pieces
      array_splice($fData, 1, 0, $sdv[0]);                                         //       add the condition as the second key
      $fData[0] = fix_Time($fData[0],$month, $day, $year);                         //       change time to UNIX time
      $formatData[] = $fData;                                                      //       create a formatted array
    }
  }
}

// sort data by option
if (!empty($_REQUEST['sort'])) {                                                   // IF a sort is selected
  $sortMe = htmlspecialchars(strip_tags($_REQUEST['sort']));                       //   get the sort type
  if($sortMe == 'a') {$chckdA = 'checked="checked"'; $sortEvent = 'severity';}     //   IF severity is selected, set variables
  if($sortMe == 'b') {$chckdB = 'checked="checked"'; $sortEvent = 'latest';}       //   IF latest is selected, set variables
  if($sortMe == 'c') {$chckdC = 'checked="checked"'; $sortEvent = 'first';}        //   IF first is selected, set variables
  if($sortMe == 'd') {$chckdD = 'checked="checked"'; $sortEvent = 'state';}        //   IF state is selected, set variables
}
else {                                                                             // OR ELSE no sorting selected
  if($sortEvent == 'severity') {$chckdA = 'checked="checked"';}                    //   IF severity is selected, indicate sevsrity
  if($sortEvent == 'latest')   {$chckdB = 'checked="checked"';}                    //   IF latest is selected, indicate latest
  if($sortEvent == 'first')    {$chckdC = 'checked="checked"';}                    //   IF first is selected, indicate first
  if($sortEvent == 'state')    {$chckdD = 'checked="checked"';}                    //   IF state is selected, indicate state
}

if($sortEvent == 'severity'){ $formatData = $formatData; $repSort = 'by severity'; }                            // sort by severity
if($sortEvent == 'first')   { usort($formatData, 'sortTimeUp'); $repSort = 'as occured'; }                      // sort by first event first
if($sortEvent == 'latest')  { usort($formatData, 'sortTimeDown'); $repSort = 'by the latest reports first'; }   // sort by latest event first
if($sortEvent == 'state')   { usort($formatData, 'byState'); $repSort = 'by state'; }                           // sort by state name

$eTotal = count($formatData);                                   // count number of reports
$reports = 'No reports listed';                                 // set defalt variable
if($eTotal >= 1) {                                              // IF there is at least 1 report
  $reports = '   <b>'.$eTotal. '</b> reports sorted '.$repSort; //   display reports and sort type
  if($eTotal == "1") {                                          //   IF there is exactly 1 report
    $reports = '   <b>'.$eTotal. '</b> report';                 //     display 1 report
  }
}

// IF more than 1 report, create radio button sort menu
if($eTotal > 1) {
  $sortButtons = '
   <form id="form1" action="'.$sri.'#SA" method ="post"><p>
    <input type="radio" name="sort" value="b" '.$chckdB.' alt="latest" onclick="this.form.submit();" />Sort by latest 
    <input type="radio" name="sort" value="c" '.$chckdC.' alt="occur" onclick="this.form.submit();"/>Sort by occurrence 
    <input type="radio" name="sort" value="a" '.$chckdA.' alt="severity" onclick="this.form.submit();" />Sort by severity 
    <input type="radio" name="sort" value="d" '.$chckdD.' alt="state" onclick="this.form.submit();" />Sort by state </p>
    <noscript><p><input name="submit" type="submit" value="SORT" style="font-size:85%" /></p></noscript>
   </form>
';  
}

foreach($formatData as $fDk  => $fDv) {                                            // FOR EACH event, perform customization
  $spa = ' &nbsp;-&nbsp; ';                                                        //   set separator
  if($fDv[2] == 'UNK') {$fDv[2] = ''; $spa = '';}                                  //   remove "UNK" - unknown
  if($fDv[1] == 'HAIL' and $fDv[2] <> '' and preg_match("/^(\d{2})$/", $fDv[2])) {
     $fDv[2] = preg_replace("/(\d{2})/", '0.${1} in', $fDv[2]);}                   //   adjust decimal point
  if($fDv[1] == 'HAIL' and $fDv[2] >= 200) {$fDv[2] = preg_replace("/(\d+)/", '<b>${1}</b>', $fDv[2]);}
  if($fDv[1] == 'HAIL' and $fDv[2] <> '') {$fDv[2] = preg_replace("/(\d+)(\d{2})/", '${1}.${2} in', $fDv[2]);}
  if($fDv[1] == 'WIND' and $fDv[2] >= '75') {$fDv[2] = '<b>'.$fDv[2].'</b>';}      //   IF mph is 75 or greater, make it bold
  if($fDv[1] == 'WIND' and $fDv[2] <> '') {$fDv[2] = $fDv[2].' mph';}              //   add mph to wind speed
  if($fDv[1] == 'TORNADO') {$bc = $tBkg; $fc = $tFont; $fDv[1] = "TORNADO";}       //   configure background color for this event
  if($fDv[1] == 'HAIL') {$bc = $hBkg; $fc = $hFont; $fDv[1] = "HAIL";}             //   configure background color for this event
  if($fDv[1] == 'WIND') {$bc = $wBkg; $fc = $wFont; $fDv[1] = "WIND";}             //   configure background color for this event
  $fDv[8] = preg_replace('/\&/U', '&amp;', $fDv[8]);                               //   fix ampersand
  ($showWFO and preg_match("/(^\d+) ([A-Z]{1,3}) (.*)/", $fDv[3])) ? $fDv[3] = dist_Dir($fDv[3]) : $fDv[3] = $fDv[3];       //   replace direction letters with words
  ($showWFO and preg_match('/\([A-Z]{3}\)/',$fDv[8])) ? preg_match('/\([A-Z]{3}\)/', $fDv[8], $nwswfo) : $fDv[8] = $fDv[8]; //   find (WFO) code
  if($showWFO and $longWFO){$fDv[8] = preg_replace("/\($nwswfo[0]\)/U", conv_wfo($nwswfo[0]), $fDv[8]);}                    //   replace WFO code with location name
  if(!$showWFO){$fDv[8] = preg_replace("/\([A-Z]{3}\)/", '', $fDv[8]);}                                                     //   delete WFO code
  (preg_match("/\*\*\*\ .* \*\*\* /Uis",$fDv[8])) ? $fDv[8] = preg_replace("/(\*\*\*\ .* \*\*\* )/", '<b>${1}</b> &nbsp;', $fDv[8]) : $fDv[8] = $fDv[8]; //   highlight special

  // construct data for table display
  $tData .= ' <tr>
  <td style="'.$tbrdr.';'.$sbrdr.'; padding: 2px 0px 2px 6px;  background-image:url('.$imagesDir.'bar5.png); color: '.$dtColor.'"><b>'.date("M j",$fDv[0]).' &nbsp;&nbsp;'.date("g:i a",$fDv[0]).'</b> '.$locTZ.'</td>
 </tr>
 <tr>
  <td style="'.$sbrdr.'; padding: 6px 0px 0px 6px; background-color: '.$bc.'; color: '.$fc.'">'.conv_state($fDv[5]).'&nbsp;&nbsp; - &nbsp;&nbsp;'.$fDv[4].' COUNTY&nbsp;&nbsp; - &nbsp;&nbsp;'.$fDv[3].'</td>
 </tr>
 <tr>
  <td style="'.$sbrdr.'; line-height:5px; background-color:'.$bc.'">&nbsp;</td>
 </tr>
 <tr>
  <td style="'.$sbrdr.'; '.$bbrdr.'; padding: 2px 6px 6px 6px; background-color:'.$bc.'; color: '.$fc.'"><b>'.$fDv[1].$spa.'</b>'.$fDv[2].' &nbsp;-&nbsp; '.$fDv[8].'</td>
 </tr>
 <tr>
  <td style="background-color:inherit">&nbsp; </td>
 </tr>
';
}

// FUNCTION - change UTC/GMT time to current time & date
function fix_Time($utc,$mo, $da, $ye) {
  $rdq = preg_replace("/\"/", '', $utc);         // remove double quotes
  $aT = $rdq + date("O");                        // utc time + GMT offset
  if($aT <= "0") {                               // IF UTC with offset is less than 0
    $aT = $aT + 2400;                            //   add 24 hours for yesterdays time
  }
  $aT = str_pad((int) $aT,4,"0",STR_PAD_LEFT);   // add leading zeros
  // IF utc time is greater than midnight (with offset) AND utc time is less that cut off time	
  ($rdq > (0000 - date("O")) and $rdq < 1200) ? $da = $da + 1 : $da = $da;  // add 1 day IF event time is after midnight
  $eTime = str_split($aT ,2);                                                   // split up time between hours & minutes
  $nDate = date("Y-m-d g:i a", mktime($eTime[0], $eTime[1], 0, $mo, $da, $ye)); // create date & time
  $stut = strtotime($nDate);                                                    // change date/time into unix time for sorting
  return $stut;                                                                 // return the time
}

// FUNCTION - add leading zero(s) to time if missing
function number_pad($number) {
  return str_pad((int) $number,4,"0",STR_PAD_LEFT);
}

// FUNCTION - convert WFO code to long name
function conv_wfo($w) {
  $w = str_replace('(', '', $w);
  $w = str_replace(')', '', $w);
  $wfo = array(
   'ABQ' => 'Albuquerque, NM', 'ABR' => 'Aberdeen, SD', 'AFC' => 'Anchorage, AK',
   'AFG' => 'Fairbanks, AK', 'AJK' => 'Juneau, AK', 'AKQ' => 'Wakefield, VA',
   'ALY' => 'Albany, NY', 'AMA' => 'Amarillo, TX', 'APX' => 'Gaylord, MI',
   'ARX' => 'La Crosse, WI', 'BGM' => 'Binghamton, NY', 'BIS' => 'Bismarck, ND',
   'BMX' => 'Birmingham, AL', 'BOI' => 'Boise, ID', 'BOU' => 'Boulder, CO',
   'BOX' => 'Boston, MA', 'BRO' => 'Brownsville, TX', 'BTV' => 'Burlington, VE',
   'BUF' => 'Buffalo, NY', 'BYZ' => 'Billings, MT', 'CAE' => 'Columbia, SC',
   'CAR' => 'Caribou, ME', 'CHS' => 'Charleston, SC', 'CLE' => 'Cleveland, OH',
   'CRP' => 'Corpus Christi, TX', 'CTP' => 'State College, PA', 'CYS' => 'Cheyenne, WY',
   'DDC' => 'Dodge City, KS', 'DLH' => 'Duluth, MN', 'DMX' => 'Des Moines, IA',
   'DTX' => 'Detroit, MI', 'DVN' => 'Quad Cities, IA', 'EAX' => 'Kansas City/Pleasant Hill, MO',
   'EKA' => 'Eureka, CA', 'EPZ' => 'El Paso, TX', 'EWX' => 'Austin/San Antonio, TX',
   'EYW' => 'Key West, FL', 'FFC' => 'Atlanta, GA', 'FGF' => 'Grand Forks, ND',
   'FGZ' => 'Flagstaff, AZ', 'FSD' => 'Sioux Falls, SD', 'FWD' => 'Dallas/Fort Worth, TX',
   'GGW' => 'Glasgow, MT', 'GID' => 'Hastings, NE', 'GJT' => 'Grand Junction, CO',
   'GLD' => 'Goodland, KS', 'GRB' => 'Green Bay, WI', 'GRR' => 'Grand Rapids, MI',
   'GSP' => 'Greenville/Spartanburg, SC', 'GUM' => 'Guam', 'GYX' => 'Portland, ME',
   'HFO' => 'Honolulu, HI', 'HGX' => 'Houston/Galveston, TX', 'HNX' => 'San Joaquin Valley, Hanford, CA',
   'HUN' => 'Huntsville, AL', 'ICT' => 'Wichita, KS', 'ILM' => 'Wilmington, NC',
   'ILN' => 'Cincinnati, OH', 'ILX' => 'Lincoln, IL', 'IND' => 'Indianapolis, IN',
   'IWX' => 'North Webster, IN', 'JAN' => 'Jackson, MS', 'JAX' => 'Jacksonville, FL',
   'JKL' => 'Jackson, KY', 'LBF' => 'North Platte, NE', 'LCH' => 'Lake Charles, LO',
   'LIX' => 'New Orleans/Baton Rouge, LO', 'LKN' => 'Elko, NV', 'LMK' => 'Louisville, KY',
   'LOT' => 'Chicago, IL', 'LOX' => 'Los Angeles, CA', 'LSX' => 'St. Louis, MO',
   'LUB' => 'Lubbock, TX', 'LWX' => 'Baltimore/Washington D.C.', 'LZK' => 'Little Rock, AK',
   'MAF' => 'Midland/Odessa, TX', 'MEG' => 'Memphis, TE', 'MFL' => 'Miami, FL',
   'MFR' => 'Medford, OR', 'MHX' => 'Morehead City, NC', 'MKX' => 'Milwaukee, WI',
   'MLB' => 'Melbourne, FL', 'MOB' => 'Mobile, AL', 'MPX' => 'Minneapolis, MN',
   'MQT' => 'Marquette, MI', 'MRX' => 'Knoxville/Tri-Cities, TE', 'MSO' => 'Missoula, MT',
   'MTR' => 'San Francisco Bay Area, Monterey, CA', 'OAX' => 'Omaha, NE', 'OHX' => 'Nashville, TE',
   'OKX' => 'New York City, Upton, NY', 'OTX' => 'Spokane, WA', 'OUN' => 'Oklahoma City, OK',
   'PAH' => 'Paducah, KY', 'PBZ' => 'Pittsburgh, PA', 'PDT' => 'Pendleton, OR',
   'PHI' => 'Philadelphia, PA', 'PIH' => 'Pocatello/Idaho Falls, ID', 'PQR' => 'Portland, OR',
   'PSR' => 'Phoenix, AZ', 'PUB' => 'Pueblo, CO', 'RAH' => 'Raleigh/Durham, NC',
   'REV' => 'Reno, NV', 'RIW' => 'Riverton, WY', 'RLX' => 'Charleston, WV',
   'RNK' => 'Roanoke, VA', 'SEW' => 'Seattle/Tacoma, WA', 'SGF' => 'Springfield, MO',
   'SGX' => 'San Diego, CA', 'SHV' => 'Shreveport, LO', 'SJT' => 'San Angelo, TX',
   'SJU' => 'San Juan, PC', 'SLC' => 'Salt Lake City, UT', 'STO' => 'Sacramento, CA',
   'TAE' => 'Tallahassee, FL', 'TBW' => 'Tampa Bay, FL', 'TFX' => 'Great Falls, MT',
   'TOP' => 'Topeka, KS', 'TSA' => 'Tulsa, OK', 'TWC' => 'Tucson, AZ',
   'UNR' => 'Rapid City, SD', 'VEF' => 'Las Vegas, NE', 'XXX' => 'missing location',);
  
  $x = str_replace(' ', "&nbsp;", $wfo[$w]);                      // keep location from splitting
  $y = '&nbsp;&nbsp;<span style="font-size:90%">('.$x.')</span>'; // reduce font size
  return $y;
}

// FUNCTION - convert short state name to long name
function conv_state($st) {
  $state_list = array('AL'=>'Alabama', 'AK'=>'Alaska', 'AZ'=>'Arizona', 'AR'=>'Arkansas', 'CA'=>'California',
                      'CO'=>'Colorado', 'CT'=>'Connecticut', 'DE'=>'Delaware','DC'=>'District Of Columbia',
                      'FL'=>'Florida', 'GA'=>'Georgia', 'HI'=>'Hawaii', 'ID'=>'Idaho', 'IL'=>'Illinois',
                      'IN'=>'Indiana', 'IA'=>'Iowa', 'KS'=>'Kansas', 'KY'=>'Kentucky', 'LA'=>'Louisiana',
                      'ME'=>'Maine', 'MD'=>'Maryland', 'MA'=>'Massachusetts', 'MI'=>'Michigan', 'MN'=>'Minnesota',
                      'MS'=>'Mississippi', 'MO'=>'Missouri', 'MT'=>'Montana', 'NE'=>'Nebraska', 'NV'=>'Nevada',
                      'NH'=>'New Hampshire', 'NJ'=>'New Jersey', 'NM'=>'New Mexico', 'NY'=>'New York', 'NC'=>'North Carolina',
                      'ND'=>'North Dakota', 'OH'=>'Ohio', 'OK'=>'Oklahoma', 'OR'=>'Oregon','PA'=>'Pennsylvania',
                      'RI'=>'Rhode Island', 'SC'=>'South Carolina', 'SD'=>'South Dakota', 'TN'=>'Tennessee', 'TX'=>'Texas',
                      'UT'=>'Utah', 'VT'=>'Vermont', 'VA'=>'Virginia', 'WA'=>'Washington', 'WV'=>'West Virginia', 'WI'=>'Wisconsin', 'WY'=>'Wyoming');
                     
  (array_key_exists($st, $state_list)) ? $state = strtoupper($state_list[$st]) : $state = 'STATE N/A'; // fix if state name is X'ed out or missing
  return $state;
}

// FUNCTION - convert distance & direction of event
function dist_Dir($a) {
  preg_match("/(^\d+) ([A-Z]{1,3}) (.*)/", $a, $b);
  $dir = array('N' => 'NORTH',
               'E' => 'EAST',
               'S' => 'SOUTH',
               'W' => 'WEST',
               'NE' => 'NORTHEAST',
               'NW' => 'NORTHWEST',
               'SE' => 'SOUTHEAST',
               'SW' => 'SOUTHWEST',
               'NNE' => 'NORTH-NORTHEAST',
               'NNW' => 'NORTH-NORTHWEST',
               'ENE' => 'EAST-NORTHEAST',
               'ESE' => 'EAST-SOUTHEAST',
               'SSE' => 'SOUTH-SOUTHEAST',
               'SSW' => 'SOUTH-SOUTHWEST',
               'WNW' => 'WEST-NORTHWEST',
               'WSW' => 'WEST-SOUTHWEST');
  ($b[1] == "1") ? $mi = 'MILE' : $mi = 'MILES';
  $strng = $b[1].' '.$mi.' ' .$dir[$b[2]].' OF '.$b[3];
  //  $strng = $b[1].' '.$mi.' ' .$b[2].' OF '.$b[3];
  return($strng);
}

// FUNCTION - get data
function curl_get_data($URL)    {
  global $haveData;
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.10) Gecko/2009042316 Firefox/3.0.10 (.NET CLR 3.5.30729)');
  curl_setopt($ch, CURLOPT_URL,$URL);
  curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml") ); 
  curl_setopt($ch, CURLOPT_NOBODY, false);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_TIMEOUT, 5);
  $cData= curl_exec($ch);
  if(strlen($cData) > "100") {
    $haveData = 1;
    curl_close ($ch);
    return $cData;
  }
  else{$haveData = '';}
}

// FUNCTION - check map data
function map_data($url) {
  global $hMap;
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.10) Gecko/2009042316 Firefox/3.0.10 (.NET CLR 3.5.30729)');
  curl_setopt($ch, CURLOPT_NOBODY, false);
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_HEADER, true);
  curl_setopt($ch, CURLOPT_FILETIME, true);            //   get the file time
  curl_setopt($ch, CURLOPT_TIMEOUT, 5);
  $cData = curl_exec($ch);
  $mapSize = curl_getinfo($ch, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
  $mapTime = curl_getinfo($ch, CURLINFO_FILETIME);     // set variable for file time information
  ($mapSize < 14000 or $mapSize == -1) ? $mapSize = 0 : $mapSize = $mapSize;
  ($mapTime !== -1) ? $mHour = date("G", $mapTime) : $mHour = date("G");
  if ($mapSize == '0') {
    $hMap = '';
    echo "<!-- unable to obtain map -->\n";            //   display remark
  }
  else {
    $hMap = true;
  }
  curl_close($ch);
  return $mapSize.'|'.$mHour;
}

// FUNCTION - sort data by latest
function sortTimeUp($x, $y) {
  if($x[0] == $y[0]) {return 0;}
  return ($x[0] > $y[0]) ? 1 : -1;
} 
		 
// FUNCTION - sort data by first
function sortTimeDown($x, $y) {
  if($x[0] == $y[0]) {return 0;}
  return ($x[0] < $y[0]) ? 1 : -1;
} 
		 
// FUNCTION - sort data by state
function byState($x, $y) {
  if($x[5] == $y[5]) {return 0;}
  return ($x[5] > $y[5]) ? 1 : -1;
} 

// FUNCTION - process time
function script_time() { // mchallis added function
  list($usec, $sec) = explode(" ", microtime());
  return ((float) $usec + (float) $sec);
} // end function load_time

$stop_timer = script_time();                                            // stop script time
$tScript = 0;                                                          // set variable
$tScript += ($stop_timer - $start_timer);                               // get start & stop time
$time_cull = sprintf("%01.4f", round($stop_timer - $start_timer, 4));   // calculate difference
$noted .= "<!-- Data process time: $time_cull seconds -->\n";           // display time results

?>
<div style="width: <?php echo $divWidth ?>; background-color:<?php  print ($bkgColor); ?>; margin: 0px auto 0px auto; border: thin solid black">
<table style="width: 96%; margin: 0px auto 0px auto; background-color:<?php  print ($bkgColor); ?>;" cellpadding="0" cellspacing="0">
 <tr>
  <td><a name="TA" id="TA"></a>&nbsp;</td>
 </tr>
 <tr>
  <td align="center"><span style="font-size:130%"><b>STORM REPORTS</b></span><br /><a href="https://www.spc.noaa.gov/climo/reports/<?php echo $viewURL ?>.html" onclick="window.open(this.href,'_blank');return false;" title=" Visit the SPC">Issued by the Storm Prediction Center</a></td>
 </tr>
 <tr>
  <td align="center"><h3><?php echo $badDate ?></h3></td>
 </tr>
 <tr>
  <td align="center">Select date for other reports</td>
 </tr>
<?php print $ddm ?>
 <tr>
  <td align="center"><a name="SA" id="SA"></a><h3><?php echo $showDate ?></h3></td>
 </tr>
 <tr>
  <td align="center"><?php echo $spc_map ?></td>
 </tr>
 <tr>
  <td align="center" style="padding-bottom:8px"><?php echo $sortButtons; echo $reports; ?></td> 
 </tr>
</table>

<table style="width: 96%; margin: 0px auto 0px auto; background-color:<?php print ($bkgColor); ?>;" cellpadding="0" cellspacing="0">
<?php print $tData ?>
 <tr>
  <td style="border: thin solid black; font-size: 90%;">
   <div style="padding: 2px 4px 2px 4px; background-color:#FEFEE9; font-size:90%">
    Daily reports from the Storm Prediction Center starts at noon UTC and ends at one minute before noon UTC the next day. This time period is between <?php echo $cutoff_time ?>am <?php echo date("T")?> and one minute before  <?php echo $cutoff_time ?>am <?php echo date("T")?> the next day.<br />
    All reports are considered  preliminary and should be treated as such.
   </div>
  </td>
 </tr>
 <tr>
  <td>&nbsp;</td>
 </tr>
</table>
</div>
<?php
echo $noted;
?>
